#! /usr/bin/python2.7
# -*- coding: UTF-8 -*-

#############################################################################
#
# Copyright (C) Labomedia Avril 2012
#
#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU General Public License
#  as published by the Free Software Foundation; either version 3
#  of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software Foundation,
#  Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
#############################################################################

import pyFluidSynth.fluidsynth
from time import sleep
import threading
from random import choice

                # alpha: note
Dictionary = {'a':0, 'b':1, 'c':2, 'd':3, 'e':4, 'f':5,
              'g':6, 'h':7, 'i':8, 'j':9, 'k':10, 'l':11,
              'm':12, 'n':13, 'o':14, 'p':15, 'q':16, 'r':17,
              's':18, 't':19, 'u':20, 'v':21, 'w':22, 'x':23,
              'y':24, 'z':25}

#              channel: (talon, coeff note, volume, life,   freq)
plage_note_dict = { 1 : (70,    2,          60,     0.4,    0.1), # yamaha grand piano
                    2:  (75,    2,          100,    0.8,    0.1), # taiko drum
                    3:  (50,    1,          100,    1.0,    0.5), # synth drum
                    4:  (50,    1,          50,     2.0,    0.2), # tubular bells
                    5:  (60,    1,          50,     0.05,   0.2), # glockenspiel
                    6:  (60,    1,          60,     0.2,    0.2), # trumpet
                    7:  (20,    1,          120,    0.3,    0.3), # tuba
                    8:  (25,    4,          70,     0.4,    0.4), # oboe
                    9:  (30,    1,          70,     0.4,    0.4), # baritone sax
                    10: (100,   0,          127,    1.0,    2.0), # gun shot
                    11: (70,    0,          90,     4.0,    4.0), # applause
                    12: (70,    2,          80,     0.1,    0.5), # melodic tom
                    13: (20,    2,          100,    0.1,    1.0), # woodblock
                    14: (75,    1,          50,     0.2,    0.2), # flute
                    15: (75,    2,          100,    0.2,    1.0), # 808 tom
                    16: (75,    0.5,        70,     0.5,    0.5)}  # reverse cymbal
                    
def sortie_to_note(fs, sortie, n):
    print n, len(sortie), sortie
    if n%19 == 0 :
        channel = 10 # gun shot
        volume = plage_note_dict[channel][2]
        life   = plage_note_dict[channel][3]
        freq   = plage_note_dict[channel][4]
        note   = plage_note_dict[channel][0] + int(Dictionary['a']*plage_note_dict[channel][1])
        for i in range(int(len(sortie)/40)):
            sleep(freq)
            thread_note(fs, channel, note, volume, life)
    elif n%28 == 0:
        channel = 11 # aplause
        volume = plage_note_dict[channel][2]
        life   = plage_note_dict[channel][3]
        freq   = plage_note_dict[channel][4]
        note   = plage_note_dict[channel][0] + int(Dictionary['a']*plage_note_dict[channel][1])
        thread_note(fs, channel, note, volume, life)
    else:
        a = 0
        if n%4 == 0:
            channel = choice([14, 6, 4, 5])
            volume = plage_note_dict[channel][2]
            life   = plage_note_dict[channel][3]
            freq   = plage_note_dict[channel][4]
            limit = 100
        if n%4 != 0:
            channel = 1
            volume = plage_note_dict[channel][2]
            life   = plage_note_dict[channel][3]
            freq   = plage_note_dict[channel][4]
            limit = 200
        if n%5 == 0:
            channel = choice([2, 3 ,12, 15, 13])
            volume = plage_note_dict[channel][2]
            life   = plage_note_dict[channel][3]
            freq   = plage_note_dict[channel][4]
            limit = 20
        if n%9 == 0:
            channel = choice([7, 9, 8])
            volume = plage_note_dict[channel][2]
            life   = plage_note_dict[channel][3]
            freq   = plage_note_dict[channel][4]
            limit = 30
        if n%13 == 0:
            channel = 16
            volume = plage_note_dict[channel][2]
            life   = plage_note_dict[channel][3]
            freq   = plage_note_dict[channel][4]
            limit = 20
            
        for j in sortie:
            a += 1
            if a < limit :
                if not j.isdigit():
                    note = plage_note_dict[channel][0] + int(Dictionary[j]*plage_note_dict[channel][1])
                    sleep(freq)
                    thread_note(fs, channel, note, volume, life)
            else:
                pass
 
def thread_sortie_to_note(fs, sortie, n):
    thread = threading.Thread(target=sortie_to_note, args=(fs, sortie, n))
    thread.start()
    
def play_note(fs, channel, note, volume, life):
    fs.noteon(channel, note, volume)
    sleep(life)
    fs.noteoff(channel, note)
    
def thread_note(fs, channel, note, volume, life):
    thread1 = threading.Thread(target=play_note, args=(fs, channel, note, volume, life))
    thread1.start()  

def set_audio():
    '''Set fluidsynth, be carefull with fonts path'''
    try:
        import pyFluidSynth.fluidsynth as fluidsynth
    
        global fs
        fs = fluidsynth.Synth()
        fs.start(driver='alsa')
        # This path is a problem because it's absolute
        sfid = fs.sfload("/usr/share/sounds/sf2/FluidR3_GM.sf2")

        # .program_select(channel,    sfid,   bank,   bank number)
        fs.program_select(  1  ,      sfid,   0,      0  ) # yamaha grand piano
        fs.program_select(  14  ,     sfid,   0,      73 ) # flute
        fs.program_select(  6  ,      sfid,   0,      56 ) # trumpet
        fs.program_select(  4  ,      sfid,   0,      14 ) # tubular bells
        fs.program_select(  5  ,      sfid,   0,      9  ) # glockenspiel
        
        fs.program_select(  7  ,      sfid,   0,      58 ) # tuba
        fs.program_select(  9  ,      sfid,   0,      67 ) # baritone sax
        fs.program_select(  8  ,      sfid,   0,      68 ) # oboe

        fs.program_select(  2  ,      sfid,   0,      116) # taiko drum
        fs.program_select(  3  ,      sfid,   0,      118) # synth drum
        fs.program_select(  12  ,     sfid,   0,      117) # melodic tom
        fs.program_select(  15  ,     sfid,   8,      118) # 808 tom
        fs.program_select(  13  ,     sfid,   0,      115) # woodblock

        fs.program_select(  16  ,     sfid,   0,      119) # reverse cymbal

        fs.program_select(  10  ,     sfid,   0,      127) # gun shot
        fs.program_select(  11  ,     sfid,   0,      126) # applause
        return fs
    
    except:
        print "For sound synthetizer, you must install:"
        print "sudo apt-get install fluidsynth fluid-soundfont-gm fluid-soundfont-gs"
        print "Be carefull with Sound Font Path"
        pass
    
if __name__ == '__main__':
    '''to test harmony in this script'''
    set_audio()
    sortie_to_note(fs,
    'coredusudmbhttpfrwikipediaorgwindexphpdiff77203858oldid76947452rcid78225424gedawybot6r271robotmodifiezh',
    1)
